;***********************     ******************************
;*
;* - DV-16400
;*  Atmega8535L
;*   AVR: 8,0 
;* 
;* :
;* InitLCD:   -  8-  
;* Main:       
;* Read_ADC1:      ,  1
;* Read_ADC2:      ,  2
;* ProtU:           
;* ProtI1:          ,  1
;* ProtI2:          ,  2
;* Data_DisplayK1:        1
;* Data_DisplayK2:        2
;* Wait_Display:          
;* Wr_Display:         ,  
;* Ncode_Display:      , 
;* Warn_Display:       ,
;* ProtU_Display:      ,   
;* ProtI1_Display:     ,    1
;* ProtI2_Display:     ,    2
;* HighP_Display:      ,   
;* Encoder:        
;* WriteUp:          
;* WriteIp1:         ,1
;* WriteIp2:         ,2
;* CaptureU1:        1 
;* CaptureU2:        2 
;* CaptureI1:        1
;* CaptureI2:        2
;* .dseg         
;*
;*      !
;***************************************************************************
.nolist
.include "m8535def.inc"

.list
;*****  

.def  CompLi2 = r4    ;  , , - 2 
.def  CompHi2 = r5    ;  ,  
.def  ConstL = r6     ;    
.def  ConstH = r7     ;     
.def  CompLu  = r8   ;  , , 
.def  CompHu  = r9   ;  ,  
.def  CompLi1 = r11    ;  , , - 1 
.def  CompHi1 = r12    ;  ,  
.def  hexH  = r14   ;   HEX 
.def  hexL  = r15   ;   HEX 
.def  time = r16	;  
.def  tmp2 = r17	;   2
.def  AdrEP= r18	;   EEPROM
.def  DatEP = r19	;   EEPROM
.def  tmp1 = r20	;   1
.def  Ncod = r21	;    
.def  prm1 = r22	;  
.def  Cnt = r23	    ;  
.def  Count0 = r24	;  0 
.def  Count1 = r25	;  1



;***** *****

.equ  RS   = 4	    ; Register Select =  4  D
.equ  RW   = 5	    ; R/W =  5  D (/WR)
.equ  Ena  = 6	    ; Enable Impuls =  6  D
.equ  BF   = 7	    ;  ,  7
.equ  ADSM  = 0b11001110  ; ADEN=1,ADSC=1,ADIE=1,ADPS2=1,ADPS1=1,ADPS0=0
.equ  ADMXu = 0b11000100  ; REFS1=1,REFS0=1,Vref=2,56V,ADC4- 
.equ  ADMXi1 = 0b11000001  ; REFS1=1,REFS0=1,Vref=2,56V,ADC1- ,1
.equ  ADMXi2 = 0b11000011  ; REFS1=1,REFS0=1,2,56V,ADC3- ,2
          
.equ  TimeDisp = 5     ;     
					   ;    , 0,22*256*5=0,28

.cseg

.org 0
rjmp  Initial	;      

.org  ADCCaddr           ;    ADC Complete
ldi   tmp1,(1<<SM0)      ; SE=0 ( "" )
out   MCUCR,tmp1         ; ""  =  
reti


Initial:;  

ldi   tmp1,High(RamEnd)  	 ;  
out   sph,tmp1
ldi   tmp1,Low(RamEnd)
out   spl,tmp1	
   
ldi   tmp1,0b11111100	       
out   PortC,tmp1   			;  PC0-PC1,  
ldi   tmp1,0b00000000	   
out   DDRC,tmp1	   			;    

ldi   tmp1,0b10001111
out   PortD,tmp1   			;  ,,   
ldi   tmp1,0b11110011
out   DDRD,tmp1	   			; PD2-PD3 ,    

clr   tmp1	       
out   PortB,tmp1            ;   
ser   tmp1	       
out   DDRB,tmp1

clr   tmp1	       
out   PortA,tmp1			;    
out   DDRA,tmp1

ldi  tmp1,(1<<CS02)|(1<<CS00);  T0
out  TCCR0,tmp1

ldi   tmp1,ADSM         ;      
out   ADCSR,tmp1

ldi tmp1,2 
mov ConstL,tmp1			;      
ldi tmp1,0 
mov ConstH,tmp1			;      
    ;   
ldi AdrEP,1  			;   
rcall EERead			;  
mov CompHu,DatEP		;     
ldi AdrEP,2 			;   
rcall EERead			;  
mov CompLu,DatEP		;     
    ;     1
ldi AdrEP,3  			;   
rcall EERead			;  
mov CompHi1,DatEP		;     
ldi AdrEP,4 			;   
rcall EERead			;  
mov CompLi1,DatEP		;     
	;     2
ldi AdrEP,5  			;   
rcall EERead			;  
mov CompHi2,DatEP		;     
ldi AdrEP,6 			;   
rcall EERead			;  
mov CompLi2,DatEP		;     

sei              		;   
rcall InitLCD           ;  -
rjmp Main               ;    
;***********************************************************************************
;   8-  ,   .
;***********************************************************************************
SendCom:	;   - 
cbi   PortD,RS	; Register Select = 
rcall LoadData
ret

SendDat:	;   -  
sbi   PortD,RS	; Register Select =  
rcall LoadData
ret

LoadData:	;   = 8 
out   PortB,prm1	;  /   D
sbi   PortD,Ena	;   
nop
nop    	    ;     450 
cbi   PortD,Ena	;   
ret

WaitBusy:	;   -  
clr   tmp1
out   DDRB,tmp1	;  B = 
cbi   PortD,RS	; Register Select = 
sbi   PortD,RW	;  =   -
WB2:
sbi   PortD,Ena	;   
nop
nop	            ;  . 320   
in    tmp1,PinB	;  BF    
cbi   PortD,Ena	;   
nop
sbrc  tmp1,BF	;   ,  -  (BF=0)
rjmp  WB2
cbi   PortD,RW	;   =  -
ser   tmp1
out   DDRB,tmp1	;  B = 
ret

InitLCD:     ;  LCD  DV16400

rcall Wait5ms	;   40    
rcall Wait5ms
rcall Wait5ms
rcall Wait5ms
rcall Wait5ms
rcall Wait5ms
rcall Wait5ms
rcall Wait5ms
ldi   prm1,$38	; $38:  , 8 , 4 
rcall Wait50us  ;   50 
rcall SendCom	;  
ldi   prm1,$38	; $38:  , 8 , 4 
rcall Wait50us  ;   50 
rcall SendCom	;  
ldi   prm1,$38	; $38:  , 8 , 4 
rcall Wait50us  ;   50 
rcall SendCom	;  
ldi   prm1,$08	; $08:  , , 
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	;  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	;   ,  
rcall WaitBusy	;   -  
rcall SendCom	;  
rcall Wait50us  ;   50 
ret
;***********************************************************************************
;    
;***********************************************************************************
Wait50us: ;    = 8 
ldi   time,130			;  
Wait51:
dec   time
brne  Wait51
ret

Wait05ms: ;    = 8,0 
ldi tmp2,10			   ;  
Wait52:
rcall wait50us
dec   tmp2
brne  Wait52
ret

Wait5ms: ;    = 8 
ldi   tmp2,100		  ;  
Wait53:
rcall wait50us
dec   tmp2
brne  Wait53
ret

Wait500: ;   500 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   tmp2,16 	    ; 16   
Wait:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0 
dec   tmp2
brne  Wait	        ; 16  = 500 
ret
;***********************************************************************************

Main: ;   

sbi PORTD,0				;   1
nop
sbi PORTD,1				;   2
nop
mov hexL,CompLu			;    
mov hexH,CompHu
rcall HexBCDcU			;   BCD-
mov hexL,CompLi2		;    
mov hexH,CompHi2
rcall HexBCDcI2			;   BCD-
mov hexL,CompLi1		;    
mov hexH,CompHi1
rcall HexBCDcI1			;   BCD-
rcall Wait_Display      ;      
Main0:
sbis PINC,2				;   1, Imax=1,00A,  SB1
rjmp Read_ADC1F  		;   
sbis PINC,3				;   2, Imax=5,0A,  SB2
rjmp Read_ADC2F  		;   
sbis PINC,7				;   ,  SB6
rjmp Encoder			;   
rjmp Main0

Read_ADC1F:				;  /

sbis PIND,3				;   ,  SA1.1
rcall HighP_Display		;   
rjmp Read_ADC1          ;   

Read_ADC2F:				;  /

sbis PIND,3				;   ,  SA1.1
rcall HighP_Display		;   
rjmp Read_ADC2          ;   

HexBCDm:	    ;   ()  BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SD1,tmp1
rcall Div10m	;  =  2
sts SD2,tmp1
rcall Div10m	;  =  3
sts SD3,tmp1
ret

HexBCDmU:	    ;   BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SU1,tmp1
rcall Div10m	;  =  2
sts SU2,tmp1
rcall Div10m	;  =  3
sts SU3,tmp1
ret

HexBCDmI:	    ;   BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SI1,tmp1
rcall Div10m	;  =  2
sts SI2,tmp1
rcall Div10m	;  =  3
sts SI3,tmp1
ret

HexBCDcU:	    ;    BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SU1c,tmp1
rcall Div10m	;  =  2
sts SU2c,tmp1
rcall Div10m	;  =  3
sts SU3c,tmp1
ret

HexBCDcI1:	    ;    BCD-,  1
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SI1c1,tmp1
rcall Div10m	;  =  2
sts SI2c1,tmp1
rcall Div10m	;  =  3
sts SI3c1,tmp1
ret

HexBCDcI2:	    ;    BCD-,  2
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SI1c2,tmp1
rcall Div10m	;  =  2
sts SI2c2,tmp1
rcall Div10m	;  =  3
sts SI3c1,tmp1
ret

Div10m:	        ;  hexH:hexL  10,
	            ;    hexH:hexL,  -  tmp1
clr  tmp1
lsl  hexL
rol  hexH
rol  tmp1       ;      10
lsl  hexL	    ;       
rol  hexH   	;    0
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
ldi  cnt,10	    ;    10 
Loop10m:
lsl  hexL	    ;     1 
rol  hexH
rol  tmp1    	;   tmp1
subi tmp1,10	; :  > 10 ?
brlo HBm1   	    ; ,  
inc  hexL       ;     1
rjmp HBm2
HBm1:
subi tmp1,-10	;   
HBm2:
dec  cnt    	;   
brne Loop10m	; ,     
ret

Read_ADC1: ;    ,  1

cbi PORTD,0				 ;   1
nop
clr Count0               ;  
clr Count1
Read_ADC10:
ldi   tmp1,ADMXu         ;      
out   ADMUX,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                    ;   
in   tmp1,ADCL           ;   -
in   tmp2,ADCH           ;   -
sts SD1u,tmp1			 ;    ,    
sts SD2u,tmp2			 ;    
cp tmp1,CompLu			 ;  U.  U.
cpc tmp2,CompHu			
brsh ProtU 		  	     ; ,  U.> U.
sbis PINC,4	    		 ;     , SB3
rjmp CaptureU1			 ;   /
Rd_ADC1u:
ldi   tmp1,ADMXi1        ;      1 
out   ADMUX,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                   ;   
in   tmp1,ADCL          ;   -
in   tmp2,ADCH          ;   -
sts SD1i,tmp1		    ;    ,    
sts SD2i,tmp2		    ;    
cp tmp1,CompLi1			;  I.  I.
cpc tmp2,CompHi1
brsh ProtI1				; ,  I.> I.
sbis PIND,2				;    , SB7
rjmp Main
sbis PIND,3             ;   , SA1
rjmp Read_ADC10         ;    SA1 
sbis PINC,5	    	    ;       1, SB4
rjmp CaptureI1			;   /
Rd_ADC1i: 
inc Count0				;      
cpi Count0,255
breq RA1
sbis PIND,2				;    , SB7
rjmp Main
rjmp Read_ADC10
RA1:
clr Count0
inc Count1
cpi Count1,TimeDisp     ;     
breq RA2                ;    
sbis PIND,2			    ;    , SB7
rjmp Main
rjmp Read_ADC10
RA2:
lds hexL,SD1u            ;    
lds hexH,SD2u
rcall HexBCDmU	         ;   BCD- 
lds hexL,SD1i            ;    
lds hexH,SD2i
rcall HexBCDmI	         ;   BCD-
rcall Data_DisplayK1	 ;     
clr Count0
clr Count1
sbis PIND,2				 ;    , SB7
rjmp Main
rjmp Read_ADC10

ProtU:;     

sbi PORTD,0				;   1
nop
sbi PORTD,1				;   2
nop
rcall ProtU_Display		;    
ProtU1:
rcall Sound             ;          
rcall Wait500 
sbis PIND,2				;    , SB7
rjmp Main
sbis PINC,7				;   ,  SB6
rjmp EncoderPU			;   
rjmp ProtU1

ProtI1:;     ,  1

sbi PORTD,0				;   1
nop
rcall ProtI1_Display    ;    
PrI1: 
rcall Sound             ;  
rcall Wait500
rcall Wait500 
sbis PIND,2				;    , SB7
rjmp Main
sbis PINC,7				;   ,  SB6
rjmp EncoderPI1			;   
rjmp PrI1

ProtI2:;     ,  2

sbi PORTD,1				;   2
nop
rcall ProtI2_Display    ;    
PrI2: 
rcall Sound     		;       
rcall Wait500
rcall Wait500 
sbis PIND,2				;    , SB7
rjmp Main
sbis PINC,7				;   ,  SB6
rjmp EncoderPI2			;   
rjmp PrI2

Read_ADC2: ;    ,  2

cbi PORTD,1			 	 ;   2
nop
clr Count0               ;  
clr Count1
Read_ADC20:
ldi   tmp1,ADMXu         ;      
out   ADMUX,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                   ;   
in   tmp1,ADCL           ;   -
in   tmp2,ADCH           ;   -
sts SD1u,tmp1			 ;    ,    
sts SD2u,tmp2			 ;    
cp tmp1,CompLu			 ;  U.  U.
cpc tmp2,CompHu				
brsh ProtU 		  	     ; ,  U.> U.
sbis PINC,4	    		 ;     , SB3
rjmp CaptureU2			 ;   /
Rd_ADC2u:
ldi   tmp1,ADMXi2        ;      2 
out   ADMUX,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                   ;   
in   tmp1,ADCL          ;   -
in   tmp2,ADCH          ;   -
sts SD1i,tmp1		    ;    ,    
sts SD2i,tmp2		    ;    
cp tmp1,CompLi2			;  I.  I.
cpc tmp2,CompHi2
brsh ProtI2				; ,  I.> I.
sbis PIND,2				;    , SB7
rjmp Main
sbis PIND,3             ;   , SA1
rjmp Read_ADC20         ;    SA1 
sbis PINC,6	    	    ;       2, SB5
rjmp CaptureI2			;   /
Rd_ADC2i: 
inc Count0				;      
cpi Count0,255
breq RA3
sbis PIND,2				;    , SB7
rjmp Main
rjmp Read_ADC20
RA3:
clr Count0
inc Count1
cpi Count1,TimeDisp     ;     
breq RA4                ;    
sbis PIND,2				;    , SB7
rjmp Main
rjmp Read_ADC20
RA4:
lds hexL,SD1u            ;    
lds hexH,SD2u
rcall HexBCDmU	         ;   BCD- 
lds hexL,SD1i            ;    
lds hexH,SD2i
rcall HexBCDmI	         ;   BCD-
rcall Data_DisplayK2	 ;     
clr Count0
clr Count1
sbis PIND,2				 ;    , SB7
rjmp Main
rjmp Read_ADC20

Sound:     ;  

cbi PORTD,7
nop
ldi XL,100
Sound0:
sbi DDRD,7          ;     1,  
rcall Wait05ms      ;   
cbi DDRD,7          ;     0,   
rcall Wait05ms      ;   
dec XL
brne Sound0
sbi PORTD,7
nop
sbi DDRD,7
ret 

Data_DisplayK1:;      1

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SU3    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SI3    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ;  1 
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ;  1
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

Data_DisplayK2:;      2

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SU3    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SI2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ;  2 
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ;  2
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

Wait_Display: ;      

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$50    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BC    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$A9    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

Wr_Display: ;   ,  

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$A4    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C4    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B4    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$B3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C0    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

Ncode_Display: ;   , 

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C5    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SD3    ; 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SD2    ; 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SD1    ; 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20   ;  ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

Warn_Display: ;   ,

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$4F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49    ; "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$4B    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$5F    ; "_"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49    ; "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$3E    ; ">"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49   ;  "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6D    ; "m"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$78    ; "x"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; "_"
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

ProtU_Display: ;   ,   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$43    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B2    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$48    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70   ;  ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$55    ; "U"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$3E    ; ">"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$55    ; "U"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

ProtI1_Display: ;   ,    1

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$43    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B2    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$54    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20   ;  ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49    ; "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$3E    ; ">"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49    ; "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

ProtI2_Display: ;   ,    2

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$43    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B2    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$54    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20   ;  ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49    ; "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$3E    ; ">"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$49    ; "I"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

HighP_Display: ;   ,   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$A0    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C3    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$E6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$54    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BA   ;  ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BB    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$1A    ; "<"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$30    ; "0"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BC    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2E    ; "."
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21    ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$10	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SU3c    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2c   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1c   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$61    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BE    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$C7    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B6    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BD    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  

ldi   prm1,$50	 ;  =    
sbr   prm1,1<<7	 ;   7,  DDRAM
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SI3c1    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c1   ; 1/100 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$31    ; "1"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2c2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI1c2   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2D    ; "-"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$4B    ; "K"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$32    ; "2"
rcall WaitBusy	;   -  
rcall SendDat    ;  
rcall Sound
ret

;************************************************************************************
;    .
;************************************************************************************
EncoderPU:;   ,    

mov Count0,CompLu	;       
mov Count1,CompHu
mov hexL,Count0		;    hex 
mov hexH,Count1
rjmp EncoderP

EncoderPI1:;   ,    ,  1

mov Count0,CompLi1	;       
mov Count1,CompHi1
mov hexL,Count0		;    hex 
mov hexH,Count1
rjmp EncoderP

EncoderPI2:;   ,    ,  2

mov Count0,CompLi2	;       
mov Count1,CompHi2
mov hexL,Count0		;    hex 
mov hexH,Count1
rjmp EncoderP

Encoder:;    

clr Count0		; 
clr Count1
mov hexL,Count0	;   hex 
mov hexH,Count1
EncoderP: 
rcall HexBCDm	;    - 
rcall Ncode_Display ;      
Encoder0:
sbis PIND,2		    ;    , SB7
rjmp Main
sbis PINC,4	    	;     , SB3
rcall WriteUp		;  /
sbis PINC,5	    	;      1, SB4
rcall WriteIp1		;  /
sbis PINC,6	    	;      2, SB5
rcall WriteIp2		;  / 
in Ncod,PINC	;    
nop
andi Ncod,3 	;      
;cpi Ncod,0 
;breq Impuls0	;    ,   
cpi Ncod,3 
breq Impuls1	;    ,   
rjmp Encoder0	;       

Impuls1:;   

sbis PIND,2		    ;    , SB7
rjmp Main
sbis PINC,4	    	;     , SB3
rcall WriteUp		;  /
sbis PINC,5	    	;      1, SB4
rcall WriteIp1		;  /
sbis PINC,6	    	;      2, SB5
rcall WriteIp2		;  / 
in Ncod,PINC		;    
nop
andi Ncod,3		;      
cpi Ncod,1 
breq Less 		;   /  
cpi Ncod,2 
breq More		;   /  
rjmp Impuls1	;       

More:;  

rcall More0		;     
mov hexL,Count0
mov hexH,Count1	;    /   
rcall HexBCDm	;    - 
rcall Ncode_Display ;      
rjmp Encoder0		;   

Less:;  

rcall Less0		;     
mov hexL,Count0
mov hexH,Count1	;    /   
rcall HexBCDm	;    - 
rcall Ncode_Display ;      
rjmp Encoder0		;   

More0:;     

inc Count0
cpi Count0,255
breq More1
ret
More1:
clr Count0
inc Count1
ret

Less0:;     

dec Count0
cpi Count0,0
breq Less1
ret
Less1:
ldi Count0,255
dec Count1
ret 

WriteUp:;      

rcall Sound
rcall Wait500
mov CompLu,Count0    ;    
mov CompHu,Count1    ;   
ldi AdrEP,1			;   
mov DatEP,Count1	; 
rcall EEWrite		;   
ldi AdrEP,2			;   
mov DatEP,Count0	; 
rcall EEWrite		;   
mov hexL,CompLu
mov hexH,CompHu
rcall HexBCDcU
rcall Wr_Display ;      
ret

WriteIp1:;      ,1

rcall Sound
rcall Wait500
cpi Count0,101
brsh Warning
mov CompLi1,Count0    ;    
mov CompHi1,Count1    ;   
ldi AdrEP,3			;   
mov DatEP,Count1	; 
rcall EEWrite		;   
ldi AdrEP,4			;   
mov DatEP,Count0	; 
rcall EEWrite		;   
mov hexL,CompLi1
mov hexH,CompHi1
rcall HexBCDcI1
rcall Wr_Display ;      
ret

Warning: ;  

rcall Warn_Display   ;   
rcall Wait500
rcall Wait500
ret 

WriteIp2:;      ,2

rcall Sound
rcall Wait500
mov CompLi2,Count0    ;    
mov CompHi2,Count1    ;   
ldi AdrEP,5			;   
mov DatEP,Count1	; 
rcall EEWrite		;   
ldi AdrEP,6			;   
mov DatEP,Count0	; 
rcall EEWrite		;   
mov hexL,CompLi2
mov hexH,CompHi2
rcall HexBCDcI2
rcall Wr_Display ;      
ret

CaptureU1:;      1 

lds CompLu,SD1u           ;    
lds CompHu,SD2u
add CompLu,ConstL 		  ;   
adc CompHu,ConstH
ldi AdrEP,1			;   
mov DatEP,CompHu	; 
rcall EEWrite		;   
ldi AdrEP,2			;   
mov DatEP,CompLu	; 
rcall EEWrite		;   
mov hexL,CompLu
mov hexH,CompHu
rcall HexBCDcU	          ;    BCD-
rcall Data_DisplayK1	  ;   
rcall Wait500	 	  
rjmp Rd_ADC1u

CaptureI1:;      1

lds CompLi1,SD1i          ;    
lds CompHi1,SD2i
add CompLi1,ConstL 		  ;   
adc CompHi1,ConstH
ldi AdrEP,3			;   
mov DatEP,CompHi1	; 
rcall EEWrite		;   
ldi AdrEP,4			;   
mov DatEP,CompLi1	; 
rcall EEWrite		;   
mov hexL,CompLi1 
mov hexH,CompHi1
rcall HexBCDcI1	          ;    BCD-
rcall Data_DisplayK1	  ;   
rcall Wait500
rjmp Rd_ADC1i

CaptureU2:;      2 

lds CompLu,SD1u           ;    
lds CompHu,SD2u
add CompLu,ConstL 		  ;   
adc CompHu,ConstH
ldi AdrEP,1			;   
mov DatEP,CompHu	; 
rcall EEWrite		;   
ldi AdrEP,2			;   
mov DatEP,CompLu	; 
rcall EEWrite		;   
mov hexL,CompLu
mov hexH,CompHu
rcall HexBCDcU	          ;    BCD-
rcall Data_DisplayK2	  ;   
rcall Wait500	  
rjmp Rd_ADC2u

CaptureI2:;      2

lds CompLi2,SD1i          ;    
lds CompHi2,SD2i
add CompLi2,ConstL 		  ;   
adc CompHi2,ConstH
ldi AdrEP,5			;   
mov DatEP,CompHi2	; 
rcall EEWrite		;   
ldi AdrEP,6			;   
mov DatEP,CompLi2	; 
rcall EEWrite		;   
mov hexL,CompLi2
mov hexH,CompHi2
rcall HexBCDcI2	          ;    BCD-
rcall Data_DisplayK2	  ;   
rcall Wait500
rjmp Rd_ADC2i

EEWrite:		;  "  EEPROM"
   
	sbic	EECR,EEWE	;  EEWE  . 0, 
	rjmp	EEWrite		;    
    ldi tmp2,0          ;      EEPROM -
	out	EEARH,tmp2 	    ;     
		                ;      EEPROM -
	out	EEARL,AdrEP 	    ;     
	out	EEDR,DatEP	    ;   -    
	sbi	EECR,EEMWE	    ;  EEMWE  
	sbi	EECR,EEWE	    ;  EEWE :  
				        ;     4- ,  
		            	;     2 
    ret

EERead:			;  " EEPROM"

	sbic	EECR, EEWE	;  EEWE  . 0, 
	rjmp	EERead		;    
    ldi tmp2,0          ;      EEPROM -
	out	EEARH,tmp2 	    ;     
	           	        ;     EEPROM -
	out	EEARL,AdrEP	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	DatEP, EEDR	    ;   
    ret

.dseg


SD1:.byte 1     ;     , BCD-
SD2:.byte 1     ; 
SD3:.byte 1     ; 
SD1i:.byte 1    ;     , hex- 
SD2i:.byte 1    ; 
SD1u:.byte 1    ;     , hex- 
SD2u:.byte 1    ; 
SU1:.byte 1     ;    , BCD-
SU2:.byte 1   ; 
SU3:.byte 1   ; 
SI1:.byte 1     ;    , BCD-
SI2:.byte 1     ;
SI3:.byte 1     ; 
SU1c:.byte 1    ;     , BCD-
SU2c:.byte 1    ; 
SU3c:.byte 1    ; 
SI1c1:.byte 1   ;       1, BCD-
SI2c1:.byte 1   ;
SI3c1:.byte 1   ; 
SI1c2:.byte 1   ;       2, BCD-
SI2c2:.byte 1   ;

.Exit

;************************************************************************************

Impuls0:;    

sbis PIND,2		    ;    , SB7
rjmp Main
sbis PINC,4	    	;     , SB3
rcall WriteUp		;  /
sbis PINC,5	    	;      1, SB4
rcall WriteIp1		;  /
sbis PINC,6	    	;      2, SB5
rcall WriteIp2		;  / 
in Ncod,PINC    	;    
andi Ncod,3		;       
cpi Ncod,1 
breq More		;   /  
cpi Ncod,2 
breq Less		;   /  
rjmp Impuls0	;       








